/*******************************************************************************
 * Main object that interacts between the user and the backend.
 ******************************************************************************/
var Tracker = {

  _branch: null,
  _domain: "extensions.netscape.tracker.",
  get branch() { return this._branch; },
  set branch(val) { this._branch = val; },
  
  get command() { return document.getElementById("tracker_panel"); },
  
  onLoad: function tr_onLoad() {
  
    // Get the preference branch and add an observer
    this.branch = Cc["@mozilla.org/preferences-service;1"].
                  getService(Ci.nsIPrefService).
                  getBranch(this._domain);
    this.branch.QueryInterface(Ci.nsIPrefBranch2).addObserver("", this, false);
    
    // update the UI 
    var self = this;
    window.setTimeout(function() { self.update(); }, 100);       
  },
  
  onUnload: function tr_onUnload() {
    
    // Remove the preference observer
    this.branch.QueryInterface(Ci.nsIPrefBranch2).removeObserver("", this);
  },
  
  update: function tr_update() {
    var disabled = this.branch.getBoolPref("disabled");
    if (disabled) {
      this.command.setAttribute("hidden", "true");
      this.command.setAttribute("disabled", "true");
      if (this.command.getAttribute("checked") == "true")
        toggleSidebar("tracker_panel");
    } else {
      this.command.removeAttribute("hidden");
      this.command.removeAttribute("disabled");
    }
  },
    
  // nsISupports
  QueryInterface: function trp_QI(iid) {
    if (iid.equals(Ci.nsIObserver) ||
        iid.equals(Ci.nsISupports))
      return this;
    throw Cr.NS_ERROR_NO_INTERFACE; 
  },
  
  observe: function trp_observe(subject, topic, data) {
    if (topic != "nsPref:changed" || data != "disabled")
      return;

    var self = this;
    window.setTimeout(function() { self.update(); }, 0);  
  }  
};